cat = { speed = 5, x = 10, y = 10 }

function cat:process(target)
	local dx, dy, distance, time
	dx = self.x - target.x
	dy = self.y - target.y
	distance = math.sqrt(dx*dx+dy*dy)
	while distance > 1 do
		local atime = coroutine.yield(self.x, self.y)
		dx = dx/distance + 0.5-math.random()
		dy = dx/distance + 0.5-math.random()
		self.x = self.x + dx*atime*self.speed
		self.y = self.y + dy*atime*self.speed
		dx = self.x - target.x
		dy = self.y - target.y
		distance = math.sqrt(dx*dx+dy*dy)
	end
	print "I'm dead!\n"
	return self.x, self.y
end
