dog = { speed = 10, x = 1, y = 1 }

function dog:process(target)
	local dx, dy, distance, time
	dx = target.x - self.x
	dy = target.y - self.y
	distance = math.sqrt(dx*dx+dy*dy)
	while distance > 1 do
		local atime = coroutine.yield(self.x, self.y)
		dx = dx/distance
		dy = dx/distance
		self.x = self.x + dx*atime*self.speed
		self.y = self.y + dy*atime*self.speed
		dx = target.x - self.x
		dy = target.y - self.y
		distance = math.sqrt(dx*dx+dy*dy)
	end
	print 'Chomp!'
	return self.x, self.y
end
